import json
import random

from pysot_toolkit.config_motion import cfg

cfg.TRACK.TYPE = 'trackNoC'

cfg.TRACK.WINDOW_INFLUENCE = round(random.uniform(0.4, 0.55), 2)#0.49
    # Online Classification influence
cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE = round(random.uniform(0.1, 0.6), 2)
    # Speed influence
cfg.TRACK.SPEED_INFLUENCE = round(random.uniform(1, 3), 2) #2.0
    # Interpolation learning rate
cfg.TRACK.LR = round(random.uniform(0.2, 0.6), 2) #0.4
cfg.TRACK.WINDOW_INFLUENCE_SLOW = round(random.uniform(0.60, 0.75), 2) #0.69
cfg.TRACK.WINDOW_INFLUENCE_FAST = round(random.uniform(0.30, 0.50), 2) #0.49
cfg.TRACK.WINDOW_INFLUENCE_MEDIUM = round(random.uniform(0.50, 0.60), 2) #0.59
cfg.TRACK.SEARCH_AREA_SLOW = 3.0
cfg.TRACK.SEARCH_AREA_FAST = 3.0 # round(random.uniform(3.20, 4.00), 2) #3.5
cfg.TRACK.SEARCH_AREA_MEDIUM = 3.0
cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_SLOW = round(random.uniform(0.10, 0.20), 2)  # 0.2
cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_FAST = round(random.uniform(0.30, 0.50), 2)  # 0.6
cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_MEDIUM = round(random.uniform(0.20, 0.30), 2)  # 0.4
cfg.TRACK.MEM_STEP = random.randint(3, 7)  # 5
cfg.TRACK.MEM_LEN = random.randint(2, 6)  # 4
cfg.TRACK.ST_MEM_COEF = round(random.uniform(0.40, 0.60), 2) #0.5
cfg.TRACK.MEM_SINK_IDX = 1
cfg.TRACK.SPEED_LAST_CALC = 3
cfg.TRACK.SCORE_INSIDE_WIDTH = 7  # 11
cfg.TRACK.SCORE_OUTSIDE_WIDTH = 14  # 23

seed = random.randint(0, 10000)
window_penalty = round(random.uniform(0.40, 0.60), 2)
sz_penalty = round(random.uniform(0.50, 0.80), 2)
threshold = round(random.uniform(0.40, 0.60), 2)
avg_motion_thes = round(random.uniform(0.17, 0.20), 2)
avg_conf_thes = round(random.uniform(0.85, 0.95), 2)
window_penalty_p = round(random.uniform(0.20, 0.35), 2)
pixel_count = round(random.uniform(0.01, 0.15), 2)
update =random.randint(5, 50)
up_score = round(random.uniform(0.10, 0.30), 2)
up_iou = round(random.uniform(0.40, 0.70), 2)

TEMPLATE_UPDATE = random.randint(0, 1)
TARGET_UPDATE_SKIPPING = random.randint(2, 7)
TARGET_UPDATE_THRESHOLD = round(random.uniform(0.70, 0.90), 2)
TAU_CLASSIFICATION = round(random.uniform(0.40, 0.80), 2)
TAU_REGRESSION = round(random.uniform(0.40, 0.80), 2)
ONLINE_CLASSIFICATION_INFLUENCE = round(random.uniform(0.20, 0.80), 2)

#########################################
hp = dict()
hp['seed_test'] = seed
hp['window_penalty'] = window_penalty
hp['sz_penalty'] = sz_penalty
hp['threshold'] = threshold
hp['window_penalty_p'] = window_penalty_p
hp['avg_motion_thes'] = avg_motion_thes
hp['avg_conf_thes'] = avg_conf_thes
hp['pixel_count'] = pixel_count
hp['update'] =update
hp['up_iou'] =up_iou
hp['up_score'] =up_score


hp['TEMPLATE_UPDATE'] = TEMPLATE_UPDATE
hp['TARGET_UPDATE_SKIPPING'] = TARGET_UPDATE_SKIPPING
hp['TARGET_UPDATE_THRESHOLD'] = TARGET_UPDATE_THRESHOLD
hp['TAU_CLASSIFICATION'] = TAU_CLASSIFICATION
hp['TAU_REGRESSION'] = TAU_REGRESSION
hp['ONLINE_CLASSIFICATION_INFLUENCE'] = ONLINE_CLASSIFICATION_INFLUENCE

hp['cfg.TRACK.WINDOW_INFLUENCE'] = cfg.TRACK.WINDOW_INFLUENCE
hp['cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE']=cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE
hp['cfg.TRACK.SPEED_INFLUENCE'] = cfg.TRACK.SPEED_INFLUENCE
# Interpolation learning rate
hp['cfg.TRACK.LR'] = cfg.TRACK.LR
hp['cfg.TRACK.WINDOW_INFLUENCE_SLOW'] = cfg.TRACK.WINDOW_INFLUENCE_SLOW
hp['cfg.TRACK.WINDOW_INFLUENCE_FAST'] = cfg.TRACK.WINDOW_INFLUENCE_FAST
hp['cfg.TRACK.WINDOW_INFLUENCE_MEDIUM']= cfg.TRACK.WINDOW_INFLUENCE_MEDIUM
hp['cfg.TRACK.SEARCH_AREA_SLOW'] = cfg.TRACK.SEARCH_AREA_SLOW
hp['cfg.TRACK.SEARCH_AREA_FAST'] = cfg.TRACK.SEARCH_AREA_FAST
hp['cfg.TRACK.SEARCH_AREA_MEDIUM'] = cfg.TRACK.SEARCH_AREA_MEDIUM
hp['cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_SLOW'] = cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_SLOW
hp['cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_FAST'] = cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_FAST
hp['cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_MEDIUM'] = cfg.TRACK.ONLINE_CLASSIFICATION_INFLUENCE_MEDIUM
hp['cfg.TRACK.MEM_STEP'] = cfg.TRACK.MEM_STEP
hp['cfg.TRACK.MEM_LEN'] = cfg.TRACK.MEM_LEN
hp['cfg.TRACK.ST_MEM_COEF'] = cfg.TRACK.ST_MEM_COEF
hp['cfg.TRACK.MEM_SINK_IDX'] = cfg.TRACK.MEM_SINK_IDX
hp['cfg.TRACK.SPEED_LAST_CALC'] = cfg.TRACK.SPEED_LAST_CALC
hp['cfg.TRACK.SCORE_INSIDE_WIDTH'] = cfg.TRACK.SCORE_INSIDE_WIDTH
hp['cfg.TRACK.SCORE_OUTSIDE_WIDTH'] = cfg.TRACK.SCORE_OUTSIDE_WIDTH

save_path = '/tmp/code/pt_dirs/hp_rand.json'

with open(save_path, 'w') as file_obj:
    json.dump(hp, file_obj, sort_keys=False, indent=8,ensure_ascii=True)

with open(save_path, encoding='utf8') as fp:
    read = json.load(fp)
